
#include <clib/alib_protos.h>
#include <exec/exec.h>
#include <exec/lists.h>
#include <exec/nodes.h>
#include <stdio.h>
#include <ctype.h>
#include <exec/types.h>
#include <intuition/intuition.h>
#include <intuition/intuitionbase.h>
#include <dos.h>
#include <dos/dos.h>
#include <proto/dos.h>
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/utility.h>
#include <proto/commodities.h>
#include <string.h>
#include <stdlib.h>
#include <pragmas/dos_pragmas.h>
#include <pragmas/exec_pragmas.h>
#include <pragmas/intuition_pragmas.h>
#include <pragmas/commodities_pragmas.h>
#include <pragmas/utility_pragmas.h>


#define STRINGSIZE 256
#define ASCSEND_VERSION "$VER: CLI_ASC_SEND 1.1 "__DATE__" "__TIME__

#define  GET_A_FILE    0
#define  GET_A_STRING  1

/*--------------------------------------------------------*/

extern struct Library *AslBase;
extern struct Library *CxBase;
extern struct Library *UtilityBase;
extern struct Library *GadToolsBase;
extern struct GfxBase *GfxBase;
extern struct IntuitionBase *IntuitionBase;

extern void __stdargs main(int argc,char **argv);
extern UBYTE      __regargs *makemem(ULONG size);
extern void                  releasemem(void *mem);
extern UBYTE __regargs *getfilebuffer(UBYTE *filename,ULONG mode);
extern void  __regargs freefilebuffer(UBYTE *buffer,ULONG size);
extern BOOL  __regargs getnextchar(UBYTE *buffer,UBYTE *where);
extern long  __regargs  Sendfile(UBYTE *filename,ULONG mode);
extern void activate_screen(UBYTE *scr);
extern void activate_window(UBYTE *wnd);
