#include "mui_ascs.h"


#define TOOLKEYLEN (STRMAXLEN)

UWORD __chip ascsendI1Data[] =
{
/* Plane 0 */
    0x0000,0x0000,0x0000,0x0400,0x0000,0x0000,0x0000,0x0C00,
    0x0000,0x0000,0x0000,0x0C00,0x0000,0x0000,0x0000,0x0C00,
    0x0000,0x0000,0x0010,0x0C00,0x0000,0x0000,0x0010,0x0C00,
    0x0000,0x0000,0x0010,0x0C00,0x0000,0x1F04,0x0010,0x0C00,
    0x0000,0x398E,0x0010,0x0C00,0x0000,0x018E,0x0010,0x0C00,
    0x0000,0x070E,0x0010,0x0C00,0x0000,0x0C04,0x0010,0x0C00,
    0x0000,0x0E04,0x0010,0x0C00,0x0000,0x0000,0x0010,0x0C00,
    0x0000,0x0E0E,0x0010,0x0C00,0x0000,0x0000,0x0010,0x0C00,
    0x0000,0x0000,0x0010,0x0C00,0x0005,0x5555,0x55D0,0x0C00,
    0x001F,0xFFFF,0xFFE0,0x0C00,0x0000,0x0000,0x0000,0x0C00,
    0x0000,0x0000,0x0000,0x0C00,0x7FFF,0xFFFF,0xFFFF,0xFC00,
/* Plane 1 */
    0xFFFF,0xFFFF,0xFFFF,0xF800,0xD555,0x5555,0x5555,0x5000,
    0xD555,0x5555,0x5555,0x5000,0xD53F,0xFFFF,0xFFC5,0x5000,
    0xD57F,0xFFFF,0xFFC5,0x5000,0xD578,0x0000,0x0085,0x5000,
    0xD571,0x5555,0x5405,0x5000,0xD575,0x4051,0x5505,0x5000,
    0xD575,0x4451,0x5505,0x5000,0xD575,0x5451,0x5505,0x5000,
    0xD575,0x5051,0x5505,0x5000,0xD575,0x5151,0x5505,0x5000,
    0xD575,0x5151,0x5505,0x5000,0xD575,0x5555,0x5505,0x5000,
    0xD575,0x5151,0x5505,0x5000,0xD571,0x5555,0x5485,0x5000,
    0xD578,0x0000,0x0045,0x5000,0xD530,0x0000,0x0025,0x5000,
    0xD540,0x0000,0x0015,0x5000,0xD555,0x5555,0x5555,0x5000,
    0xD555,0x5555,0x5555,0x5000,0x8000,0x0000,0x0000,0x0000,
};

struct Image ascsendI1 =
{
    0, 0,			/* Upper left corner */
    54, 22, 2,			/* Width, Height, Depth */
    ascsendI1Data,		/* Image data */
    0x0003, 0x0000,		/* PlanePick, PlaneOnOff */
    NULL			/* Next image */
};

struct DiskObject ascsend =
{
    WB_DISKMAGIC,		/* Magic Number */
    WB_DISKVERSION,		/* Version */
    {				/* Embedded Gadget Structure */
	NULL,			/* Next Gadget Pointer */
	0, 0, 54, 23,		/* Left,Top,Width,Height */
	GADGIMAGE | GADGHCOMP,	/* Flags */
	RELVERIFY,		/* Activation Flags */
	BOOLGADGET,		/* Gadget Type */
	(APTR)&ascsendI1,	/* Render Image */
	NULL,			/* Select Image */
	NULL,			/* Gadget Text */
	NULL,			/* Mutual Exclude */
	NULL,			/* Special Info */
	100,			/* Gadget ID */
	(APTR) 0x0001,		/* User Data (Revision) */
    },
    WBTOOL,			/* Icon Type */
    NULL,			/* Default Tool */
    NULL,			/* Tool Type Array **do_ToolTypes */
    NO_ICON_POSITION,		/* Current X */
    NO_ICON_POSITION,		/* Current Y */
    NULL,			/* Drawer Structure */
    NULL,			/* Tool Window */
    4096				/* Stack Size */
};


void Save_to_icon()
{
 ULONG specials,keys,num,n;
 ULONG i;
 struct hotkey *k;
 ULONG  number;
 UBYTE  *str;
 get(special_list,MUIA_List_Entries,&specials);
 get(key_list    ,MUIA_List_Entries,&keys);
 keys *= 2;
 num = 20 + keys + specials;
 {
  if(ascsend.do_ToolTypes = (char **)AllocVec(num * sizeof(char *),MEMF_PUBLIC | MEMF_CLEAR))
  {
   ascsend.do_ToolTypes[0] = makemem(TOOLKEYLEN);strcpy(*(ascsend.do_ToolTypes),"DONOTWAIT");
   ascsend.do_ToolTypes[1] = makemem(TOOLKEYLEN);
   
 strcpy(*(ascsend.do_ToolTypes + 1),"REQPATH=");
    strcat(*(ascsend.do_ToolTypes + 1),requestpath);
   ascsend.do_ToolTypes[2] = makemem(TOOLKEYLEN);
    strcpy(*(ascsend.do_ToolTypes + 2),"REQFILE=");
    strcat(*(ascsend.do_ToolTypes + 2),requestfile);
   ascsend.do_ToolTypes[3] = makemem(TOOLKEYLEN);
    get(delay_int,MUIA_String_Integer,&number);
    sprintf(*(ascsend.do_ToolTypes + 3),"DELAY=%ld",number);
   ascsend.do_ToolTypes[4] = makemem(TOOLKEYLEN);
    get(delaychar_int,MUIA_String_Integer,&number);
    sprintf(*(ascsend.do_ToolTypes + 4),"DELAYCHAR=%ld",number);
   if(k = FindEntry(special_list,CXID_POPUP))
   {
    ascsend.do_ToolTypes[5] = makemem(TOOLKEYLEN);
    strcpy(*(ascsend.do_ToolTypes + 5),"CX_POPKEY=");
    strcat(*(ascsend.do_ToolTypes + 5),k->h_description); 
   }
   if(k = FindEntry(special_list,CXID_FILEREQ))
   {
    ascsend.do_ToolTypes[6] = makemem(TOOLKEYLEN);
    strcpy(*(ascsend.do_ToolTypes + 6),"REQUESTKEY=");
    strcat(*(ascsend.do_ToolTypes + 6),k->h_description); 
   }
   if(k = FindEntry(special_list,CXID_STOP))
   {
    ascsend.do_ToolTypes[7] = makemem(TOOLKEYLEN);
    strcpy(*(ascsend.do_ToolTypes + 7),"STOPKEY=");
    strcat(*(ascsend.do_ToolTypes + 7),k->h_description); 
   }
   if(k = FindEntry(special_list,CXID_INFO))
   {
    ascsend.do_ToolTypes[8] = makemem(TOOLKEYLEN);
    strcpy(*(ascsend.do_ToolTypes + 8),"INFOKEY=");
    strcat(*(ascsend.do_ToolTypes + 8),k->h_description); 
   }
   ascsend.do_ToolTypes[9] = makemem(TOOLKEYLEN);
    get(edit_string,MUIA_String_Contents,&str);
    sprintf(*(ascsend.do_ToolTypes + 9),"EDITOR=%s",str);

   ascsend.do_ToolTypes[10] = makemem(TOOLKEYLEN);
    get(rec_start,MUIA_String_Contents,&str);
    sprintf(*(ascsend.do_ToolTypes + 10),"RECSTARTKEY=%s",str);
  
   ascsend.do_ToolTypes[11] = makemem(TOOLKEYLEN);
    get(rec_stop,MUIA_String_Contents,&str);
    sprintf(*(ascsend.do_ToolTypes + 11),"RECSTOPKEY=%s",str);  
  
  ascsend.do_ToolTypes[12] = makemem(TOOLKEYLEN);
    get(rec_file,MUIA_String_Contents,&str);
    sprintf(*(ascsend.do_ToolTypes + 12),"RECFILE=%s",str);

  ascsend.do_ToolTypes[13] = makemem(TOOLKEYLEN);
    get(rec_min_delay,MUIA_String_Integer,&number);
    sprintf(*(ascsend.do_ToolTypes + 13),"MIN_DELAY=%ld",number);

  ascsend.do_ToolTypes[14] = makemem(TOOLKEYLEN);
    get(rec_handler_pri,MUIA_String_Integer,&number);
    sprintf(*(ascsend.do_ToolTypes + 14),"HANDLER_PRIORITY=%ld",number);

  ascsend.do_ToolTypes[15] = makemem(TOOLKEYLEN);
    get(rec_include_mb,MUIA_Selected,&number);
    if (number) sprintf(*(ascsend.do_ToolTypes + 15),"INCLUDE_MB=YES");
    else        sprintf(*(ascsend.do_ToolTypes + 15),"INCLUDE_MB=NO");

  ascsend.do_ToolTypes[16] = makemem(TOOLKEYLEN);
    get(rec_include_delay,MUIA_Selected,&number);
    if (number) sprintf(*(ascsend.do_ToolTypes + 16),"INCLUDE_DELAY=YES");
    else        sprintf(*(ascsend.do_ToolTypes + 16),"INCLUDE_DELAY=NO");

  ascsend.do_ToolTypes[17] = makemem(TOOLKEYLEN);
    get(rec_max,MUIA_String_Integer,&number);
    sprintf(*(ascsend.do_ToolTypes + 17),"REC_MAXCHAR=%ld",number);

  ascsend.do_ToolTypes[18] = makemem(TOOLKEYLEN);
    get(rec_max_on,MUIA_Selected,&number);
    if (number) sprintf(*(ascsend.do_ToolTypes + 18),"REC_MAX_ON=YES");
    else        sprintf(*(ascsend.do_ToolTypes + 18),"REC_MAX_ON=NO");

   n = 0;
   for(i=19;;i += 2)
   {
    DoMethod(key_list,MUIM_List_GetEntry,n,&k);
    if(!k)break;
    ascsend.do_ToolTypes[i]     = makemem(TOOLKEYLEN);
    ascsend.do_ToolTypes[i + 1] = makemem(TOOLKEYLEN);
    sprintf(*(ascsend.do_ToolTypes + i)    ,"HOTKEY%ld=%s",n,k->h_description);
    sprintf(*(ascsend.do_ToolTypes + i + 1),"FILE%ld=%s",n,k->h_filename); 
    n++;
   }
   PutDiskObject("ascsend",&ascsend); 
   for(i = 0;i < num ; i++)if(ascsend.do_ToolTypes[i])releasemem(ascsend.do_ToolTypes[i]);
   releasemem(ascsend.do_ToolTypes);
  }
 }   
}

